<?php

class ControllerExtensionPaymentXunhuwechat extends Controller
{

    private function _redirect($url, $status = 302) {
        header('location: ' . str_replace(array('&amp;', "\n", "\r"), array('&', '', ''), $url), true, $status);
        exit();
    }
    public function index()
    {
        $this->load->model('checkout/order');
        $this->load->model('extension/payment/xunhuwechat');
        $this->load->language('extension/payment/xunhuwechat');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        
        $data['text_wait'] = $this->language->get('text_wait');
        
        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['button_back'] = $this->language->get('button_back');
        
        return $this->load->view('extension/payment/xunhuwechat', $data);
    }

    private function error_view($order_id,$error){
        $data=array();
        
        $data['text_wait'] = '5秒后跳转支付页面...';
        $data['Your_BillNo'] = $data['text_billno'] = $order_id;
        $data['text_failure_wait']='3秒后跳转支付页面...';
        $data['title']=$data['heading_title'] = '订单异常';
        $data['text_response']  = $error;
        $data['text_failure'] = $error;
        $data['continue'] = $this->url->link('checkout/checkout', '', 'SSL');
        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['column_right'] = $this->load->controller('common/column_right');
        $data['footer'] = $this->load->controller('common/footer');
        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');
        
        $this->response->setOutput($this->load->view('extension/payment/hpireturns', $data));
        return;
    }
    
    public function query(){
        $this->load->model('checkout/order');
        $this->load->model('extension/payment/xunhuwechat');
        $this->language->load('extension/payment/xunhuwechat');
         
        $order_id                 = $this->session->data['order_id'];
        $succeed_status = $this->config->get('payment_xunhuwechat_order_succeed_status_id');
        $order_info               = $this->model_checkout_order->getOrder($order_id);
        if(!$order_info){
            $json['error'] ='Ops!Something is wrong.';
            $this->response->addHeader('Content-Type: application/json');
            echo json_encode($json);
            exit;
        }
         
        $result =$this->db->query(
            "select order_id
	         from `" . DB_PREFIX . "order`
            where order_status_id='$succeed_status'
            and order_id = '$order_id'
            limit 1;");
        if($result->num_rows){
            $json['error']=null;
            $this->session->data['cart'] = array();
            $this->session->data['order_id'] = null;
            $json['success'] = $this->url->link('checkout/success', '', 'SSL');
            $this->response->addHeader('Content-Type: application/json');
          	$this->cart->clear();
            unset($this->session->data['order_id']);
            echo json_encode($json);
            exit;
        }else{
            $json['error']=null;
            $json['success'] = false;
            $this->response->addHeader('Content-Type: application/json');
            echo json_encode($json);
            exit;
        }
    }
	
	public function order_query(){
		$this->load->model('checkout/order');
        $this->load->model('extension/payment/xunhuwechat');
        $this->language->load('extension/payment/xunhuwechat');
        $order_id                 = $this->session->data['order_id'];
		$mchid              = $this->config->get('payment_xunhuwechat_appid');//测试账户，仅支持一元内支付
        $private_key          = $this->config->get('payment_xunhuwechat_appsecret');//测试账户，仅支持一元内支付
        $order_id_prefix       = $this->config->get('payment_xunhuwechat_order_prefix');
		$data=array(
			'mchid'=>$mchid ,
			'out_trade_no'=>$order_id_prefix.$order_id,
			'nonce_str'=>str_shuffle(time())
		);
		$data['sign']=$this->generate_xh_hash($data,$private_key);
		$response = $this->http_post_json('https://admin.xunhuweb.com/pay/query', json_encode($data));
		$result     	  = $response?json_decode($response,true):null;
		if(isset($result['status'])&&$result['status']=='complete'){
			$json['error']=null;
            $this->session->data['cart'] = array();
            $this->session->data['order_id'] = null;
            $json['success'] = $this->url->link('checkout/success', '', 'SSL');
            $this->response->addHeader('Content-Type: application/json');
          	$this->cart->clear();
            unset($this->session->data['order_id']);
            echo json_encode($json);
            exit; 
		}else{
			$json['error']=null;
            $json['success'] = false;
            $this->response->addHeader('Content-Type: application/json');
            echo json_encode($json);
            exit;
		}
	}
	
    public function notify(){
        $this->load->model('checkout/order');
        $this->load->model('extension/payment/xunhuwechat');
        $this->language->load('extension/payment/xunhuwechat');
      
        $mchid              = $this->config->get('payment_xunhuwechat_appid');//测试账户，仅支持一元内支付
        $private_key          = $this->config->get('payment_xunhuwechat_appsecret');//测试账户，仅支持一元内支付
        $order_id_prefix       = $this->config->get('payment_xunhuwechat_order_prefix');
        $data=(array)json_decode(file_get_contents('php://input'));
        $out_trade_no = isset($data['out_trade_no'])?$data['out_trade_no']:null;
        $order_id=isset($data['order_id'])?$data['order_id']:null;
        $hash =$this->generate_xh_hash($data,$private_key);
        if($data['sign']!=$hash){
            //签名验证失败
            echo '签名错误';exit;
        }
        $out_trade_no = substr($out_trade_no, strlen($order_id_prefix));
        $success_status = $this->config->get('payment_xunhuwechat_order_succeed_status_id');
        $db = DB_PREFIX;
        $result =$this->db->query(
            "select *
            from `{$db}order`
            where order_id = '{$out_trade_no}'
            and order_status_id='{$success_status}'
            limit 1;");
        if($result->num_rows){
             print 'success';exit;
        }
      if($data['status']=='complete'){
            $message = "Transaction Id:{$order_id}";
           if(method_exists($this->model_checkout_order,'confirm')){
               $order_info =  $this->model_checkout_order->getOrder($out_trade_no);
               if ($order_info && $order_info['order_status_id']) {
                 $this->model_checkout_order->update($out_trade_no, $success_status, $message, true);
               }else{
                 $this->model_checkout_order->confirm($out_trade_no, $success_status, $message, true);
               }
             }else{
               $this->model_checkout_order->addOrderHistory($out_trade_no, $success_status, $message, true);
             }
        }
        //以下是处理成功后输出，当支付平台接收到此消息后，将不再重复回调当前接口
        print 'success';
        exit;
    }
    
    public function send()
    {
     $this->load->model('checkout/order');
        $this->load->model('extension/payment/xunhuwechat');
        $this->language->load('extension/payment/xunhuwechat');
        $order_id = $this->session->data['order_id'];
        $json=array();
        if(empty($order_id)){
            $json['error'] = '购物车已清空，请重新购物！';
            $this->response->setOutput(json_encode($json));
            $this->response->addHeader('Content-Type: application/json');
            return;
        }
        
        $order = $this->model_checkout_order->getOrder($order_id);
        if(!$order){
            $json['error'] = '购物车已清空，请重新购物！';
            $this->response->setOutput(json_encode($json));
            $this->response->addHeader('Content-Type: application/json');
            return;
        }
        
        try {
            $json['success'] =$this->url->link('extension/payment/xunhuwechat/pay','',true);
        } catch (Exception $e) {
            $json['error'] = "errcode:{$e->getCode()},errmsg:{$e->getMessage()}";
        }
        
        $this->response->setOutput(json_encode($json));
        $this->response->addHeader('Content-Type: application/json');
    }
    public function callback(){
        $this->load->model('checkout/order');
        $this->load->model('extension/payment/xunhuwechat');
        $this->language->load('extension/payment/xunhuwechat');
        $order_id = $this->session->data['order_id'];
        $db = DB_PREFIX;
        $result =$this->db->query(
            "select *
	        from `{$db}order`
            where order_id = '{$order_id}'
                 and order_status_id='{$success_status}'
            limit 1;");
        $succeed_status = $this->config->get('payment_xunhuwechat_order_succeed_status_id');
        $db = DB_PREFIX;
      	$_result =$this->db->query(
        	"select *
                from `{$db}order`
                where order_id = '{$order_id}'
                and order_status_id='{$succeed_status}'
                limit 1;");
        if($_result->num_rows){
			$this->cart->clear();
			unset($this->session->data['order_id']);
			$this->_redirect($this->url->link('checkout/success', '', 'SSL'));
			return;
		}else{
			$this->_redirect($this->url->link('checkout/checkout', '', 'SSL'));
			return;
		}
    }
    public function pay(){
        $this->load->model('checkout/order');
        $this->load->model('extension/payment/xunhuwechat');
        $this->language->load('extension/payment/xunhuwechat');
        $order_id = $this->session->data['order_id'];
      	$http_type = ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') || (isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] == 'https')) ? 'https://' : 'http://';
        $json=array();
        if(empty($order_id)){
            $this->error_view($order_id,'购物车已清空，请重新购物！');
            return;
        }
        
        $order = $this->model_checkout_order->getOrder($order_id);
        if(!$order){
            $this->error_view($order_id,'购物车已清空，请重新购物！');
            return;
        }

        $succeed_status = $this->config->get('payment_xunhuwechat_order_succeed_status_id');
        $wait_status = $this->config->get('payment_xunhuwechat_order_failed_status_id');
        $currency = $order['currency_code'];
        $order_prefix = $this->config->get('payment_xunhuwechat_order_prefix');
        $amount = round($this->currency->format($order['total'], $currency, $order['currency_value'], FALSE),2);
        
        $mchid             = $this->config->get('payment_xunhuwechat_appid');//测试账户，仅支持一元内支付
      	$private_key	   = $this->config->get('payment_xunhuwechat_appsecret');
        $web_url           = $this->config->get('payment_xunhuwechat_weburl');
        $order_id_prefix   = $this->config->get('payment_xunhuwechat_order_prefix');

        $result =$this->db->query(
            "select order_id
	         from `" . DB_PREFIX . "order`
             where order_status_id='{$succeed_status}'
                and order_id = '{$order_id}'
             limit 1;");
        
        if($result->num_rows){
            $json['error']=null;
            $this->session->data['cart'] = array();
            unset($this->session->data['order_id']);
            header("location:".$this->url->link('checkout/success', '', 'SSL'),true,302);
            exit;
        }
        try {
            $data = array(
    	        'mchid'=>$mchid,
                'out_trade_no'=>$order_id_prefix.$order_id,
             	'body'=>"#{$order_id}",
              	'type'=> 'wechat',
              	'total_fee'=> $amount*100,
              	'notify_url'=>$this->url->link('extension/payment/xunhuwechat/notify', '', 'SSL'),
              	'nonce_str'=>str_shuffle(time())
    	    );
          if($this->is_wechat_app()){
	         	 $data['redirect_url']=$this->url->link('extension/payment/xunhuwechat/callback', '', 'SSL');
	        	 $data['sign']     = $this->generate_xh_hash($data,$private_key);
	        	 $pay_url     = $this->data_link('https://admin.xunhuweb.com/pay/cashier', $data);
	        	 header("Location:". htmlspecialchars_decode($pay_url,ENT_NOQUOTES));
		    	 exit;
	        }
           //h5支付
        	if($this->is_app_client()){
	        	 $data['trade_type'] = 'WAP';
	        	 $data['wap_url']    = $web_url;//h5支付域名必须备案，然后找服务商绑定
	        	 $data['wap_name']   = '迅虎网络';
	        	 $data['sign']       = $this->generate_xh_hash($data,$private_key);
		         $response   		 = $this->http_post_json('https://admin.xunhuweb.com/pay/payment', json_encode($data));
		         $result     		 = $response?json_decode($response,true):null;
				 $callback_url		 = $this->url->link('checkout/checkout', '', 'SSL');
		         if(!$result){
		             throw new Exception('Internal server error',500);
		         }
				 if($result['code']=='501'){
					 unset($this->session->data['order_id']);
					 $this->_redirect($this->url->link('checkout/checkout', '', 'SSL'));
					 exit;
				 }
		         $sign       	  =  $this->generate_xh_hash($result,$private_key);
		         if($result['return_code']!='SUCCESS'){
		          	 throw new Exception($result['err_msg'],$result['err_code']);
		         }
              	 if(!isset( $result['sign'])|| $sign!=$result['sign']){
		             throw new Exception('Invalid sign!',40029);
		         }
		         $pay_url =$result['mweb_url'].'&redirect_url='.urlencode($this->url->link('extension/payment/xunhuwechat/callback', '', 'SSL'));
				 ?>
					<html>
					<head>
					<meta charset="UTF-8">
					<title>收银台付款</title>
					<meta id="viewport" name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
					<meta name="format-detection" content="telephone=no">
					<link rel="stylesheet" href="/catalog/view/theme/default/images/xh/style.css">
					</head>
					<body ontouchstart="" class="bggrey">
						<div class="xh-title"><img src="https://api.xunhupay.com/content/images/wechat-s.png" alt="" style="vertical-align: middle"> 微信支付收银台</div>

							<div class="xhpay ">
							   <img class="logo" alt="" src="/catalog/view/theme/default/images/xh/img_14.png">

								<span class="price"><?php echo $amount ?></span>
							</div>
							<div class="xhpaybt">
								<a href="<?php echo $pay_url;?>" class="xunhu-btn xunhu-btn-green" >微信支付</a>
							</div>
							<div class="xhpaybt">
								<a href="<?php echo $callback_url;?>" class="xunhu-btn xunhu-btn-border-green" >取消支付</a>
							</div>
							<div class="xhtext" align="center">支付完成后，如需售后服务请联系客服</div>
							<div class="xhfooter" align="center">迅虎网络提供技术支持</div>
							<script type="text/javascript" src="/catalog/view/theme/default/images/xh/jquery-2.1.4.js"></script>
							<script type="text/javascript">
							 (function($){
									window.view={
										query:function () {
											$.ajax({
												type: "POST",
												url: '<?php print $this->url->link('extension/payment/xunhuwechat/order_query','',true);?>',
												timeout:6000,
												cache:false,
												dataType:'json',
												success:function(e){
													if (e && e.success) {
														location.href = "<?php echo $this->url->link('checkout/success', '', 'SSL') ?>";
														return;
													}
													
													setTimeout(function(){window.view.query();}, 2000);
												},
												error:function(){
													 setTimeout(function(){window.view.query();}, 2000);
												}
											});
										}
									};								
									  window.view.query();								
								})(jQuery);
								</script>
					</body>
					</html>
				 <?php
		    	 exit;
            }
    	    $data['sign']=$this->generate_xh_hash($data,$private_key);
    	    $response = $this->http_post_json('https://admin.xunhuweb.com/pay/payment', json_encode($data));
          	$result     	  = $response?json_decode($response,true):null;
            if(!$result){
           	 	throw new Exception('Internal server error',500);
            }
			if($result['code']=='501'){
				 ?>
					<script>alert('订单号重复，请重新发起支付!');</script>
				 <?
				 unset($this->session->data['order_id']);
				 $this->_redirect($this->url->link('checkout/checkout', '', 'SSL'));
				 exit;
			 }
          	if($result['return_code']!='SUCCESS'){
            	throw new Exception($result['err_msg'],$result['err_code']);
          	}
          	$sign       	  = $this->generate_xh_hash($result,$private_key);
          	if(!isset( $result['sign'])|| $sign!=$result['sign']){
            	throw new Exception('Invalid sign!',40029);
          	}
          	$url =$result['code_url'];
	   	 ?>
	    	<html>
	    	<head>
	        <meta charset="utf-8">
	        <meta http-equiv="X-UA-Compatible" content="IE=edge">
	        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
	        <meta name="keywords" content="">
	        <meta name="description" content="">   
	        <title>微信支付</title>
	        <style>
	             *{margin:0;padding:0;}
	              body{padding-top: 50px; background: #f2f2f4;}
	             .clearfix:after { content: "."; display: block; height: 0; clear: both; visibility: hidden; }
	            .clearfix { display: inline-block; }
	            * html .clearfix { height: 1%; }
	            .clearfix { display: block; }
	              .xh-title{height:35px;line-height:35px;text-align:center;font-size:30px;margin-bottom:20px;font-weight:300;}
	              .qrbox{max-width: 900px;margin: 0 auto;background:#f9f9f9;padding:35px 20px 20px 50px;border:1px solid #ddd;border-top:3px solid #44b549;}
	              
	              .qrbox .left{width: 40%;
	                float: left;    
	                 display: block;
	                margin: 0px auto;}
	              .qrbox .left .qrcon{
	                border-radius: 10px;
	                background: #fff;
	                overflow: visible;
	                text-align: center;
	                padding-top:25px;
	                color: #555;
	                box-shadow: 0 3px 3px 0 rgba(0, 0, 0, .05);
	                vertical-align: top;
	                -webkit-transition: all .2s linear;
	                transition: all .2s linear;
	              }
	                .qrbox .left .qrcon .logo{width: 100%;}
	                .qrbox .left .qrcon .title{font-size: 16px;margin: 10px auto;width: 100%;}
	                .qrbox .left .qrcon .price{font-size: 22px;margin: 0px auto;width: 100%;}
	                .qrbox .left .qrcon .bottom{border-radius: 0 0 10px 10px;
	                width: 100%;
	                background: #32343d;
	                color: #f2f2f2;padding:15px 0px;text-align: center;font-size: 14px;}
	               .qrbox .sys{width: 60%;float: right;text-align: center;padding-top:20px;font-size: 12px;color: #ccc}
	               .qrbox img{max-width: 100%;}
	               @media (max-width : 767px){
	            .qrbox{padding:20px;}
	                .qrbox .left{width: 90%;float: none;}   
	                .qrbox .sys{display: none;}
	               }
	               
	               @media (max-width : 320px){
	               body{padding-top:35px;}
	              }
	              @media ( min-width: 321px) and ( max-width:375px ){
	            body{padding-top:35px;}
	              }
	        </style>
	        <script type="text/javascript" src="/catalog/view/theme/default/images/xh/jquery-2.1.4.js"></script>
            <script type="text/javascript" src="/catalog/view/theme/default/images/xh/qrcode.js"></script>
	        </head>
	        
	        <body>
	         <div class="xh-title">微信支付收银台</div>
	          <div class="qrbox clearfix">
	          <div class="left">
	             <div class="qrcon">
	               <h5><img src="/catalog/view/theme/default/images/xh/wechat.png" alt=""></h5>
	                 <div class="title"><?php print $data['body'];?></div>
	                 <div class="price"><?php echo $currency ?><?php echo  round($data['total_fee']/100,2);?></div>
	                 <div align="center"><div id="wechat_qrcode" style="width: 250px;height: 250px;"></div></div>
	                 <div class="bottom">
	                 		请使用微信扫一扫<br/>
	        				扫描二维码支付
	                 	
	                 </div>
	             </div>
	             
	      </div>
	         <div class="sys"><img src="/catalog/view/theme/default/images/xh/wechat-sys.png" alt=""></div>
	      </div>
	         <script type="text/javascript">
	         (function($){
	        		window.view={
	    				query:function () {
	    			        $.ajax({
	    			            type: "POST",
	    			            url: '<?php print $this->url->link('extension/payment/xunhuwechat/query','',true);?>',
	    			            timeout:6000,
	    			            cache:false,
	    			            dataType:'json',
	    			            success:function(e){
	    			            	if (e && e.success) {
	        			                //$('#wechat_qrcode').css('color','green').text('已支付成功，跳转中...');
	        		                    //location.href = "<?php echo $this->url->link('extension/payment/xunhuwechat/callback', '', 'SSL') ?>";
										location.href = "<?php echo $this->url->link('checkout/success', '', 'SSL') ?>";
	        		                    return;
	        		                }
	    			                
	    			                setTimeout(function(){window.view.query();}, 2000);
	    			            },
	    			            error:function(){
	    			            	 setTimeout(function(){window.view.query();}, 2000);
	    			            }
	    			        });
	    			    }
	        		};
	        		var qrcode = new QRCode(document.getElementById("wechat_qrcode"), {
		              width : 220,
		              height : 220
		            });
		            
		            <?php if(!empty($url)){
		              ?>
		              qrcode.makeCode("<?php print $url?>");
		              window.view.query();
		            <?php 
		            }?>
	        		
	        	})(jQuery);
	        	</script>
	    	</body>
	    </html>
    	<?php
          exit;
    	} catch (Exception $e) {
    	    echo $e->getMessage();
    	    exit;
    	}
    }
    public  function is_ios() {
        $ua = strtolower($_SERVER ['HTTP_USER_AGENT']);
        return strripos ( $ua, 'iphone' ) != false || strripos ( $ua, 'ipad' ) != false;
    }
    public function is_wechat_app(){
        return strripos($_SERVER['HTTP_USER_AGENT'],'micromessenger')!=false;
    }
    public static function is_app_client(){
        if(!isset($_SERVER['HTTP_USER_AGENT'])){
            return false;
        }
    
        $u=strtolower($_SERVER['HTTP_USER_AGENT']);
        if($u==null||strlen($u)==0){
            return false;
        }
    
        preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/',$u,$res);
    
        if($res&&count($res)>0){
            return true;
        }
    
        if(strlen($u)<4){
            return false;
        }
    
        preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/',substr($u,0,4),$res);
        if($res&&count($res)>0){
            return true;
        }
    
        $ipadchar = "/(ipad|ipad2)/i";
        preg_match($ipadchar,$u,$res);
        if($res&&count($res)>0){
            return true;
        }
    
        return false;
    }
    
    /**
     * http_post传输
     * @param array $url
     * @param string $jsonStr
     */
    public static function http_post_json($url, $jsonStr){
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_URL, $url);
	    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);
        curl_setopt($ch,CURLOPT_SSL_VERIFYHOST,FALSE);
	    curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonStr);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array(
	            'Content-Type: application/json; charset=utf-8',
	            'Content-Length: ' . strlen($jsonStr)
	        )
	    );
	    $response = curl_exec($ch);
	    $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	    curl_close($ch);
	 
	    return $response;
	}
	 /**
     * url拼接
     * @param array $url
     * @param string $datas
     */
	public static function data_link($url,$datas){
		ksort($datas);
        reset($datas);
        $pre =array();
        foreach ($datas as $key => $data){
            if(is_null($data)||$data===''){
                continue;
            }

            $pre[$key]=$data;
        }

        $arg  = '';
        $qty = count($pre);
        $index=0;
		 foreach ($pre as $key=>$val){
		 		$val=urlencode($val);
			 	$arg.="$key=$val";
	            if($index++<($qty-1)){
	                $arg.="&amp;";
	            }	
        }
        return $url.'?'.$arg;
	}
   /**
     * 签名方法
     * @param array $datas
     * @param string $hashkey
     */
    public static function generate_xh_hash(array $datas,$hashkey){
        ksort($datas);
        reset($datas);

        $pre =array();
        foreach ($datas as $key => $data){
            if(is_null($data)||$data===''){
                continue;
            }
            if($key=='sign'){
                continue;
            }
            $pre[$key]=$data;
        }

        $arg  = '';
        $qty = count($pre);
        $index=0;

        foreach ($pre as $key=>$val){
            $arg.="$key=$val";
            if($index++<($qty-1)){
                $arg.="&";
            }
        }
        // var_dump($arg.'&key='.$hashkey);
        // file_put_contents(realpath(dirname(__FILE__)) . "/log.txt",json_encode($arg.'&key='.$hashkey)."\r\n",FILE_APPEND);
        return strtoupper(md5($arg.'&key='.$hashkey));
    }
    
}